Description

This patch:

e Makes code block rendering consistent across formats, which is important for plugins, client-side scripts and styling.
e Makes sure rendered language name is escaped.
¢ Exposes user-supplied language name in an HTML attribute, so that client-side scripts and Redmine plugins can always access

it.

The patch applies to the current Textile and Markdown formatters. The very same change to the planned CommonMark formatter will

be attached to #32424.

Please see below for design decisions rationale.

Code block rendering

<pre><code> vs. just<pre>:

Textile supports blocks without code (<pre>...</pre>), while code can be part of such blocks. Typically, there is just one and only
code block per <pre> block, but it's possible to have more than one code block in a <pre> block. So in general, we cannot avoid the
code tag in the HTML rendered from Textile.

While it is possible to render only the pre tag for Markdown code blocks and rendering libraries do have option for that, we should
use the code tag too to be consistent. Fortunatelly, this is already the case and it is even what CommonMark spec suggests.

No-code-blocks-in-Markdown
Markdown does not have preformatted blocks except for code blocks. Code blocks are either idented or fenced, but both are meant

to represent code (spec).

The fenced code blocks can also carry an info string, which is used to determine the languge of the code.

Comparison of different renderers:

Formatter

No-code block — HTML

Code block w/o lang —
HTML

Code block with
supported lang —» HTML

Code block with
unsupported lang —
HTML

Redmine Textile

<pre>...</pre>

<pre><code>...</code>
</pre>

<pre><code class="ruby
syntaxhl">...</code></pr
e>

<pre><code>...</code>
</pre>

#32424

</pre>

syntaxhl">...</code></pr
e>

CommonMark reference |N/A <pre><code>...</code> |<pre><code <pre><code

renderer </pre> class="language-ruby">. |class="language-foo">...
..</code></pre> </code></pre>

Redmine Markdown N/A <pres>...</pre> <pre><code class="ruby |<pre>...</pre>
syntaxhl">...</code></pr
e>

Redmine CommonMark | N/A <pre><code>...</code> |<pre><code class="ruby |<pre>...</pre>

It's quite obvious that we should follow the Textile behavior to be consistent.

Original data language
https://www.redmine.org/issues/32424
https://spec.commonmark.org/0.29/#indented-code-blocks
https://www.redmine.org/issues/32424

The user-supplied language information is currently dropped if the particular language does not have any lexer for syntax
highlighting. However, there are several use cases when this information is valuable:

e Plugins like redmine_wysiwyg_editor

e Data format converters like redmine_reformat

e Client-side scripts that could render or decorate specific languages in their own way, e.g. mermaid

For the reasons above, the information has to be carried on the code tag. I've examined a few projects and libraries related to the
topic to find an appropriate name for such attribute. The conclusion is to use <code data-language="foo" ...>.

Resulting code block rendering:

Formatter No-code block — | Code block w/o | Code block with | Code block with
HTML lang —» HTML supported lang | unsupported lang
— HTML — HTML
All Redmine <pres>...</pre> <pre><code>...</ | <pre><code <pre><code
formatters code></pre> class="ruby data-language="f
syntaxhl" 00">...</code></

data-language="r
uby">...</code><
/pre>

pre>

Quality Assurance, Security & Compatibility

e QA: Added new unit tests and updated the existing ones.
e Security: Previously, Textile formatter did not escape language name and relied on validating it against syntax highlighter, while
expecting language names to be safe. Language names are now always subject to escaping.

¢ Compatibility:

o The rendered HTML is now the same as the HTML from Textile.

o The added data-language attribute should be indeed ignored by unconcerned components.

o | don't really expect that anybody to rely on getting <pre> and not <pre><code>, especially when it is the current behavior
of Textile. I've verified this on redmine_wysiwyg_editor as a rare example of a potentially concerned plugin.

So I'm convinced it is safe to include this in any minor release.

Related issues:

Related to Redmine - Feature #32424: CommonMark Markdown Text Formatting

Closed

Associated revisions

Revision 21182 - 2021-08-15 22:59 - Marius BALTEANU

Add "data-language" attribute to code block with the user-supplied language for CommonMark formater (#35104, #32424).

Patch by Martin Cizek.

Revision 21183 - 2021-08-15 23:00 - Marius BALTEANU

Unify code block and add "data-language" attribute with the user-supplied language for Textile and Markdown formaters (#35104).

Patch by Martin Cizek.

History

#1 - 2021-04-15 22:00 - Martin Cizek

- File 0002-application_helper _test.patch added

#2 - 2021-04-15 22:02 - Martin Cizek

...accidentaly marked this as a defect, it should have been patch. Thank you.

#3 - 2021-06-03 14:46 - Go MAEDA

- Tracker changed from Defect to Patch

#4 - 2021-08-15 13:10 - Marius BALTEANU

- Assignee set to Marius BALTEANU

- Target version set to 5.0.0
https://redmine.org/plugins/redmine_wysiwyg_editor
https://redmine.org/plugins/redmine_reformat
#5 - 2021-08-15 14:36 - Marius BALTEANU
- Related to Feature #32424: CommonMark Markdown Text Formatting added

#6 - 2021-08-16 00:24 - Marius BALTEANU

- Status changed from New to Closed

Patches committed, thanks again Martin for your work on this.

Files
0001-unify-code-blocks.patch 6.37 KB 2021-04-15 Martin Cizek
0002-application_helper_test.patch 1.78 KB 2021-04-15 Martin Cizek
